/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for Group resource in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Group extends GenericJson {

  /**
   * Is the group created by admin *
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean adminCreated;

  /**
   * List of aliases (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> aliases;

  /**
   * Description of the group
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String description;

  /**
   * Email of Group
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String email;

  /**
   * Unique identifier of Group (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Group name
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String name;

  /**
   * List of non editable aliases (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> nonEditableAliases;

  /**
   * Is the group created by admin *
   * The value returned may be {@code null}.
   */
  public Boolean getAdminCreated() {
    return adminCreated;
  }

  /**
   * Is the group created by admin *
   * The value set may be {@code null}.
   */
  public Group setAdminCreated(Boolean adminCreated) {
    this.adminCreated = adminCreated;
    return this;
  }

  /**
   * List of aliases (Read-only)
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getAliases() {
    return aliases;
  }

  /**
   * List of aliases (Read-only)
   * The value set may be {@code null}.
   */
  public Group setAliases(java.util.List<String> aliases) {
    this.aliases = aliases;
    return this;
  }

  /**
   * Description of the group
   * The value returned may be {@code null}.
   */
  public String getDescription() {
    return description;
  }

  /**
   * Description of the group
   * The value set may be {@code null}.
   */
  public Group setDescription(String description) {
    this.description = description;
    return this;
  }

  /**
   * Email of Group
   * The value returned may be {@code null}.
   */
  public String getEmail() {
    return email;
  }

  /**
   * Email of Group
   * The value set may be {@code null}.
   */
  public Group setEmail(String email) {
    this.email = email;
    return this;
  }

  /**
   * Unique identifier of Group (Read-only)
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * Unique identifier of Group (Read-only)
   * The value set may be {@code null}.
   */
  public Group setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Kind of resource this is.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * The value set may be {@code null}.
   */
  public Group setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Group name
   * The value returned may be {@code null}.
   */
  public String getName() {
    return name;
  }

  /**
   * Group name
   * The value set may be {@code null}.
   */
  public Group setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * List of non editable aliases (Read-only)
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getNonEditableAliases() {
    return nonEditableAliases;
  }

  /**
   * List of non editable aliases (Read-only)
   * The value set may be {@code null}.
   */
  public Group setNonEditableAliases(java.util.List<String> nonEditableAliases) {
    this.nonEditableAliases = nonEditableAliases;
    return this;
  }

}
