/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON response template for List Mobile Devices operation in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class MobileDevices extends GenericJson {

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * List of Mobile Device objects.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<MobileDevice> mobiledevices;

  static {
    // hack to force ProGuard to consider MobileDevice used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(MobileDevice.class);
  }

  /**
   * Token used to access next page of this result.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String nextPageToken;

  /**
   * Kind of resource this is.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * The value set may be {@code null}.
   */
  public MobileDevices setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * List of Mobile Device objects.
   * The value returned may be {@code null}.
   */
  public java.util.List<MobileDevice> getMobiledevices() {
    return mobiledevices;
  }

  /**
   * List of Mobile Device objects.
   * The value set may be {@code null}.
   */
  public MobileDevices setMobiledevices(java.util.List<MobileDevice> mobiledevices) {
    this.mobiledevices = mobiledevices;
    return this;
  }

  /**
   * Token used to access next page of this result.
   * The value returned may be {@code null}.
   */
  public String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * Token used to access next page of this result.
   * The value set may be {@code null}.
   */
  public MobileDevices setNextPageToken(String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

}
