/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for Org Unit resource in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class OrgUnit extends GenericJson {

  /**
   * Should block inheritance
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean blockInheritance;

  /**
   * Description of OrgUnit
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String description;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Name of OrgUnit
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String name;

  /**
   * Path of OrgUnit
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String orgUnitPath;

  /**
   * Path of parent OrgUnit
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String parentOrgUnitPath;

  /**
   * Should block inheritance
   * The value returned may be {@code null}.
   */
  public Boolean getBlockInheritance() {
    return blockInheritance;
  }

  /**
   * Should block inheritance
   * The value set may be {@code null}.
   */
  public OrgUnit setBlockInheritance(Boolean blockInheritance) {
    this.blockInheritance = blockInheritance;
    return this;
  }

  /**
   * Description of OrgUnit
   * The value returned may be {@code null}.
   */
  public String getDescription() {
    return description;
  }

  /**
   * Description of OrgUnit
   * The value set may be {@code null}.
   */
  public OrgUnit setDescription(String description) {
    this.description = description;
    return this;
  }

  /**
   * Kind of resource this is.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * The value set may be {@code null}.
   */
  public OrgUnit setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Name of OrgUnit
   * The value returned may be {@code null}.
   */
  public String getName() {
    return name;
  }

  /**
   * Name of OrgUnit
   * The value set may be {@code null}.
   */
  public OrgUnit setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * Path of OrgUnit
   * The value returned may be {@code null}.
   */
  public String getOrgUnitPath() {
    return orgUnitPath;
  }

  /**
   * Path of OrgUnit
   * The value set may be {@code null}.
   */
  public OrgUnit setOrgUnitPath(String orgUnitPath) {
    this.orgUnitPath = orgUnitPath;
    return this;
  }

  /**
   * Path of parent OrgUnit
   * The value returned may be {@code null}.
   */
  public String getParentOrgUnitPath() {
    return parentOrgUnitPath;
  }

  /**
   * Path of parent OrgUnit
   * The value set may be {@code null}.
   */
  public OrgUnit setParentOrgUnitPath(String parentOrgUnitPath) {
    this.parentOrgUnitPath = parentOrgUnitPath;
    return this;
  }

}
