/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for address.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UserAddress extends GenericJson {

  /**
   * Country.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String country;

  /**
   * Country code.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String countryCode;

  /**
   * Custom type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String customType;

  /**
   * Extended Address.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String extendedAddress;

  /**
   * Formatted address (read-only field)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String formatted;

  /**
   * Locality.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String locality;

  /**
   * Other parts of address.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String poBox;

  /**
   * Postal code.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String postalCode;

  /**
   * If this is user's primary address. Only one entry could be marked as primary.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean primary;

  /**
   * Region.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String region;

  /**
   * User supplied address was structured. Structured addresses are NOT supported at this time. You
   * might be able to write structured addresses, but any values will eventually be clobbered.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean sourceIsStructured;

  /**
   * Street.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String streetAddress;

  /**
   * Each entry can have a type which indicates standard values of that entry. For example address
   * could be of home, work etc. In addition to the standard type, an entry can have a custom type
   * and can take any value. Such type should have the CUSTOM value as type and also have a
   * customType value.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String type;

  /**
   * Country.
   * The value returned may be {@code null}.
   */
  public String getCountry() {
    return country;
  }

  /**
   * Country.
   * The value set may be {@code null}.
   */
  public UserAddress setCountry(String country) {
    this.country = country;
    return this;
  }

  /**
   * Country code.
   * The value returned may be {@code null}.
   */
  public String getCountryCode() {
    return countryCode;
  }

  /**
   * Country code.
   * The value set may be {@code null}.
   */
  public UserAddress setCountryCode(String countryCode) {
    this.countryCode = countryCode;
    return this;
  }

  /**
   * Custom type.
   * The value returned may be {@code null}.
   */
  public String getCustomType() {
    return customType;
  }

  /**
   * Custom type.
   * The value set may be {@code null}.
   */
  public UserAddress setCustomType(String customType) {
    this.customType = customType;
    return this;
  }

  /**
   * Extended Address.
   * The value returned may be {@code null}.
   */
  public String getExtendedAddress() {
    return extendedAddress;
  }

  /**
   * Extended Address.
   * The value set may be {@code null}.
   */
  public UserAddress setExtendedAddress(String extendedAddress) {
    this.extendedAddress = extendedAddress;
    return this;
  }

  /**
   * Formatted address (read-only field)
   * The value returned may be {@code null}.
   */
  public String getFormatted() {
    return formatted;
  }

  /**
   * Formatted address (read-only field)
   * The value set may be {@code null}.
   */
  public UserAddress setFormatted(String formatted) {
    this.formatted = formatted;
    return this;
  }

  /**
   * Locality.
   * The value returned may be {@code null}.
   */
  public String getLocality() {
    return locality;
  }

  /**
   * Locality.
   * The value set may be {@code null}.
   */
  public UserAddress setLocality(String locality) {
    this.locality = locality;
    return this;
  }

  /**
   * Other parts of address.
   * The value returned may be {@code null}.
   */
  public String getPoBox() {
    return poBox;
  }

  /**
   * Other parts of address.
   * The value set may be {@code null}.
   */
  public UserAddress setPoBox(String poBox) {
    this.poBox = poBox;
    return this;
  }

  /**
   * Postal code.
   * The value returned may be {@code null}.
   */
  public String getPostalCode() {
    return postalCode;
  }

  /**
   * Postal code.
   * The value set may be {@code null}.
   */
  public UserAddress setPostalCode(String postalCode) {
    this.postalCode = postalCode;
    return this;
  }

  /**
   * If this is user's primary address. Only one entry could be marked as primary.
   * The value returned may be {@code null}.
   */
  public Boolean getPrimary() {
    return primary;
  }

  /**
   * If this is user's primary address. Only one entry could be marked as primary.
   * The value set may be {@code null}.
   */
  public UserAddress setPrimary(Boolean primary) {
    this.primary = primary;
    return this;
  }

  /**
   * Region.
   * The value returned may be {@code null}.
   */
  public String getRegion() {
    return region;
  }

  /**
   * Region.
   * The value set may be {@code null}.
   */
  public UserAddress setRegion(String region) {
    this.region = region;
    return this;
  }

  /**
   * User supplied address was structured. Structured addresses are NOT supported at this time. You
   * might be able to write structured addresses, but any values will eventually be clobbered.
   * The value returned may be {@code null}.
   */
  public Boolean getSourceIsStructured() {
    return sourceIsStructured;
  }

  /**
   * User supplied address was structured. Structured addresses are NOT supported at this time. You
   * might be able to write structured addresses, but any values will eventually be clobbered.
   * The value set may be {@code null}.
   */
  public UserAddress setSourceIsStructured(Boolean sourceIsStructured) {
    this.sourceIsStructured = sourceIsStructured;
    return this;
  }

  /**
   * Street.
   * The value returned may be {@code null}.
   */
  public String getStreetAddress() {
    return streetAddress;
  }

  /**
   * Street.
   * The value set may be {@code null}.
   */
  public UserAddress setStreetAddress(String streetAddress) {
    this.streetAddress = streetAddress;
    return this;
  }

  /**
   * Each entry can have a type which indicates standard values of that entry. For example address
   * could be of home, work etc. In addition to the standard type, an entry can have a custom type
   * and can take any value. Such type should have the CUSTOM value as type and also have a
   * customType value.
   * The value returned may be {@code null}.
   */
  public String getType() {
    return type;
  }

  /**
   * Each entry can have a type which indicates standard values of that entry. For example address
   * could be of home, work etc. In addition to the standard type, an entry can have a custom type
   * and can take any value. Such type should have the CUSTOM value as type and also have a
   * customType value.
   * The value set may be {@code null}.
   */
  public UserAddress setType(String type) {
    this.type = type;
    return this;
  }

}
