/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for instant messenger of an user.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UserIm extends GenericJson {

  /**
   * Custom protocol.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String customProtocol;

  /**
   * Custom type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String customType;

  /**
   * Instant messenger id.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String im;

  /**
   * If this is user's priamry im. Only one entry could be marked as primary.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean primary;

  /**
   * Protocol used in the instant messenger. It should be one of the values from ImProtocolTypes
   * map. Simalar to type, it can take a CUSTOM value and specify the custom name in customProtocol
   * field.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String protocol;

  /**
   * Each entry can have a type which indicates standard types of that entry. For example instant
   * messengers could be of home, work etc. In addition to the standard type, an entry can have a
   * custom type and can take any value. Such types should have the CUSTOM value as type and also
   * have a customType value.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String type;

  /**
   * Custom protocol.
   * The value returned may be {@code null}.
   */
  public String getCustomProtocol() {
    return customProtocol;
  }

  /**
   * Custom protocol.
   * The value set may be {@code null}.
   */
  public UserIm setCustomProtocol(String customProtocol) {
    this.customProtocol = customProtocol;
    return this;
  }

  /**
   * Custom type.
   * The value returned may be {@code null}.
   */
  public String getCustomType() {
    return customType;
  }

  /**
   * Custom type.
   * The value set may be {@code null}.
   */
  public UserIm setCustomType(String customType) {
    this.customType = customType;
    return this;
  }

  /**
   * Instant messenger id.
   * The value returned may be {@code null}.
   */
  public String getIm() {
    return im;
  }

  /**
   * Instant messenger id.
   * The value set may be {@code null}.
   */
  public UserIm setIm(String im) {
    this.im = im;
    return this;
  }

  /**
   * If this is user's priamry im. Only one entry could be marked as primary.
   * The value returned may be {@code null}.
   */
  public Boolean getPrimary() {
    return primary;
  }

  /**
   * If this is user's priamry im. Only one entry could be marked as primary.
   * The value set may be {@code null}.
   */
  public UserIm setPrimary(Boolean primary) {
    this.primary = primary;
    return this;
  }

  /**
   * Protocol used in the instant messenger. It should be one of the values from ImProtocolTypes
   * map. Simalar to type, it can take a CUSTOM value and specify the custom name in customProtocol
   * field.
   * The value returned may be {@code null}.
   */
  public String getProtocol() {
    return protocol;
  }

  /**
   * Protocol used in the instant messenger. It should be one of the values from ImProtocolTypes
   * map. Simalar to type, it can take a CUSTOM value and specify the custom name in customProtocol
   * field.
   * The value set may be {@code null}.
   */
  public UserIm setProtocol(String protocol) {
    this.protocol = protocol;
    return this;
  }

  /**
   * Each entry can have a type which indicates standard types of that entry. For example instant
   * messengers could be of home, work etc. In addition to the standard type, an entry can have a
   * custom type and can take any value. Such types should have the CUSTOM value as type and also
   * have a customType value.
   * The value returned may be {@code null}.
   */
  public String getType() {
    return type;
  }

  /**
   * Each entry can have a type which indicates standard types of that entry. For example instant
   * messengers could be of home, work etc. In addition to the standard type, an entry can have a
   * custom type and can take any value. Such types should have the CUSTOM value as type and also
   * have a customType value.
   * The value set may be {@code null}.
   */
  public UserIm setType(String type) {
    this.type = type;
    return this;
  }

}
