/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for an organization entry.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UserOrganization extends GenericJson {

  /**
   * The cost center of the users department.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String costCenter;

  /**
   * Custom type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String customType;

  /**
   * Department within the organization.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String department;

  /**
   * Description of the organization.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String description;

  /**
   * The domain to which the organization belongs to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String domain;

  /**
   * Location of the organization. This need not be fully qualified address.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String location;

  /**
   * Name of the organization
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String name;

  /**
   * If it user's primary organization.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean primary;

  /**
   * Symobol of the organization.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String symbol;

  /**
   * Title (designation) of the user in the organization.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String title;

  /**
   * Each entry can have a type which indicates standard types of that entry. For example
   * organization could be of school, work etc. In addition to the standard type, an entry can have
   * a custom type and can give it any name. Such types should have the CUSTOM value as type and
   * also have a CustomType value.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String type;

  /**
   * The cost center of the users department.
   * The value returned may be {@code null}.
   */
  public String getCostCenter() {
    return costCenter;
  }

  /**
   * The cost center of the users department.
   * The value set may be {@code null}.
   */
  public UserOrganization setCostCenter(String costCenter) {
    this.costCenter = costCenter;
    return this;
  }

  /**
   * Custom type.
   * The value returned may be {@code null}.
   */
  public String getCustomType() {
    return customType;
  }

  /**
   * Custom type.
   * The value set may be {@code null}.
   */
  public UserOrganization setCustomType(String customType) {
    this.customType = customType;
    return this;
  }

  /**
   * Department within the organization.
   * The value returned may be {@code null}.
   */
  public String getDepartment() {
    return department;
  }

  /**
   * Department within the organization.
   * The value set may be {@code null}.
   */
  public UserOrganization setDepartment(String department) {
    this.department = department;
    return this;
  }

  /**
   * Description of the organization.
   * The value returned may be {@code null}.
   */
  public String getDescription() {
    return description;
  }

  /**
   * Description of the organization.
   * The value set may be {@code null}.
   */
  public UserOrganization setDescription(String description) {
    this.description = description;
    return this;
  }

  /**
   * The domain to which the organization belongs to.
   * The value returned may be {@code null}.
   */
  public String getDomain() {
    return domain;
  }

  /**
   * The domain to which the organization belongs to.
   * The value set may be {@code null}.
   */
  public UserOrganization setDomain(String domain) {
    this.domain = domain;
    return this;
  }

  /**
   * Location of the organization. This need not be fully qualified address.
   * The value returned may be {@code null}.
   */
  public String getLocation() {
    return location;
  }

  /**
   * Location of the organization. This need not be fully qualified address.
   * The value set may be {@code null}.
   */
  public UserOrganization setLocation(String location) {
    this.location = location;
    return this;
  }

  /**
   * Name of the organization
   * The value returned may be {@code null}.
   */
  public String getName() {
    return name;
  }

  /**
   * Name of the organization
   * The value set may be {@code null}.
   */
  public UserOrganization setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * If it user's primary organization.
   * The value returned may be {@code null}.
   */
  public Boolean getPrimary() {
    return primary;
  }

  /**
   * If it user's primary organization.
   * The value set may be {@code null}.
   */
  public UserOrganization setPrimary(Boolean primary) {
    this.primary = primary;
    return this;
  }

  /**
   * Symobol of the organization.
   * The value returned may be {@code null}.
   */
  public String getSymbol() {
    return symbol;
  }

  /**
   * Symobol of the organization.
   * The value set may be {@code null}.
   */
  public UserOrganization setSymbol(String symbol) {
    this.symbol = symbol;
    return this;
  }

  /**
   * Title (designation) of the user in the organization.
   * The value returned may be {@code null}.
   */
  public String getTitle() {
    return title;
  }

  /**
   * Title (designation) of the user in the organization.
   * The value set may be {@code null}.
   */
  public UserOrganization setTitle(String title) {
    this.title = title;
    return this;
  }

  /**
   * Each entry can have a type which indicates standard types of that entry. For example
   * organization could be of school, work etc. In addition to the standard type, an entry can have
   * a custom type and can give it any name. Such types should have the CUSTOM value as type and
   * also have a CustomType value.
   * The value returned may be {@code null}.
   */
  public String getType() {
    return type;
  }

  /**
   * Each entry can have a type which indicates standard types of that entry. For example
   * organization could be of school, work etc. In addition to the standard type, an entry can have
   * a custom type and can give it any name. Such types should have the CUSTOM value as type and
   * also have a CustomType value.
   * The value set may be {@code null}.
   */
  public UserOrganization setType(String type) {
    this.type = type;
    return this;
  }

}
