/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for a phone entry.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UserPhone extends GenericJson {

  /**
   * Custom Type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String customType;

  /**
   * If this is user's primary phone or not.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean primary;

  /**
   * Each entry can have a type which indicates standard types of that entry. For example phone
   * could be of home_fax, work, mobile etc. In addition to the standard type, an entry can have a
   * custom type and can give it any name. Such types should have the CUSTOM value as type and also
   * have a customType value.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String type;

  /**
   * Phone number.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String value;

  /**
   * Custom Type.
   * The value returned may be {@code null}.
   */
  public String getCustomType() {
    return customType;
  }

  /**
   * Custom Type.
   * The value set may be {@code null}.
   */
  public UserPhone setCustomType(String customType) {
    this.customType = customType;
    return this;
  }

  /**
   * If this is user's primary phone or not.
   * The value returned may be {@code null}.
   */
  public Boolean getPrimary() {
    return primary;
  }

  /**
   * If this is user's primary phone or not.
   * The value set may be {@code null}.
   */
  public UserPhone setPrimary(Boolean primary) {
    this.primary = primary;
    return this;
  }

  /**
   * Each entry can have a type which indicates standard types of that entry. For example phone
   * could be of home_fax, work, mobile etc. In addition to the standard type, an entry can have a
   * custom type and can give it any name. Such types should have the CUSTOM value as type and also
   * have a customType value.
   * The value returned may be {@code null}.
   */
  public String getType() {
    return type;
  }

  /**
   * Each entry can have a type which indicates standard types of that entry. For example phone
   * could be of home_fax, work, mobile etc. In addition to the standard type, an entry can have a
   * custom type and can give it any name. Such types should have the CUSTOM value as type and also
   * have a customType value.
   * The value set may be {@code null}.
   */
  public UserPhone setType(String type) {
    this.type = type;
    return this;
  }

  /**
   * Phone number.
   * The value returned may be {@code null}.
   */
  public String getValue() {
    return value;
  }

  /**
   * Phone number.
   * The value set may be {@code null}.
   */
  public UserPhone setValue(String value) {
    this.value = value;
    return this;
  }

}
