/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for Photo object in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UserPhoto extends GenericJson {

  /**
   * Height in pixels of the photo
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer height;

  /**
   * Unique identifier of User (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Mime Type of the photo
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String mimeType;

  /**
   * Base64 encoded photo data
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String photoData;

  /**
   * Primary email of User (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String primaryEmail;

  /**
   * Width in pixels of the photo
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer width;

  /**
   * Height in pixels of the photo
   * The value returned may be {@code null}.
   */
  public Integer getHeight() {
    return height;
  }

  /**
   * Height in pixels of the photo
   * The value set may be {@code null}.
   */
  public UserPhoto setHeight(Integer height) {
    this.height = height;
    return this;
  }

  /**
   * Unique identifier of User (Read-only)
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * Unique identifier of User (Read-only)
   * The value set may be {@code null}.
   */
  public UserPhoto setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Kind of resource this is.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * The value set may be {@code null}.
   */
  public UserPhoto setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Mime Type of the photo
   * The value returned may be {@code null}.
   */
  public String getMimeType() {
    return mimeType;
  }

  /**
   * Mime Type of the photo
   * The value set may be {@code null}.
   */
  public UserPhoto setMimeType(String mimeType) {
    this.mimeType = mimeType;
    return this;
  }

  /**
   * Base64 encoded photo data
   * The value returned may be {@code null}.
   */
  public String getPhotoData() {
    return photoData;
  }

  /**
   * Base64 encoded photo data
   * The value set may be {@code null}.
   */
  public UserPhoto setPhotoData(String photoData) {
    this.photoData = photoData;
    return this;
  }

  /**
   * Primary email of User (Read-only)
   * The value returned may be {@code null}.
   */
  public String getPrimaryEmail() {
    return primaryEmail;
  }

  /**
   * Primary email of User (Read-only)
   * The value set may be {@code null}.
   */
  public UserPhoto setPrimaryEmail(String primaryEmail) {
    this.primaryEmail = primaryEmail;
    return this;
  }

  /**
   * Width in pixels of the photo
   * The value returned may be {@code null}.
   */
  public Integer getWidth() {
    return width;
  }

  /**
   * Width in pixels of the photo
   * The value set may be {@code null}.
   */
  public UserPhoto setWidth(Integer width) {
    this.width = width;
    return this;
  }

}
